Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 559)
+++ lemon/concepts/graph_components.h	(revision 985)
@@ -582,68 +620,59 @@
       typedef IterableDigraphComponent Digraph;
 
-      /// \name Base iteration
-      ///
-      /// This interface provides functions for iteration on digraph items
+      /// \name Base Iteration
+      ///
+      /// This interface provides functions for iteration on digraph items.
       ///
       /// @{
 
-      /// \brief Gives back the first node in the iterating order.
-      ///
-      /// Gives back the first node in the iterating order.
-      ///
+      /// \brief Return the first node.
+      ///
+      /// This function gives back the first node in the iteration order.
       void first(Node&) const {}
 
-      /// \brief Gives back the next node in the iterating order.
-      ///
-      /// Gives back the next node in the iterating order.
-      ///
+      /// \brief Return the next node.
+      ///
+      /// This function gives back the next node in the iteration order.
       void next(Node&) const {}
 
-      /// \brief Gives back the first arc in the iterating order.
-      ///
-      /// Gives back the first arc in the iterating order.
-      ///
+      /// \brief Return the first arc.
+      ///
+      /// This function gives back the first arc in the iteration order.
       void first(Arc&) const {}
 
-      /// \brief Gives back the next arc in the iterating order.
-      ///
-      /// Gives back the next arc in the iterating order.
-      ///
+      /// \brief Return the next arc.
+      ///
+      /// This function gives back the next arc in the iteration order.
       void next(Arc&) const {}
 
-
-      /// \brief Gives back the first of the arcs point to the given
-      /// node.
-      ///
-      /// Gives back the first of the arcs point to the given node.
-      ///
+      /// \brief Return the first arc incomming to the given node.
+      ///
+      /// This function gives back the first arc incomming to the
+      /// given node.
       void firstIn(Arc&, const Node&) const {}
 
-      /// \brief Gives back the next of the arcs points to the given
-      /// node.
-      ///
-      /// Gives back the next of the arcs points to the given node.
-      ///
+      /// \brief Return the next arc incomming to the given node.
+      ///
+      /// This function gives back the next arc incomming to the
+      /// given node.
       void nextIn(Arc&) const {}
 
-      /// \brief Gives back the first of the arcs start from the
+      /// \brief Return the first arc outgoing form the given node.
+      ///
+      /// This function gives back the first arc outgoing form the
       /// given node.
-      ///
-      /// Gives back the first of the arcs start from the given node.
-      ///
       void firstOut(Arc&, const Node&) const {}
 
-      /// \brief Gives back the next of the arcs start from the given
-      /// node.
-      ///
-      /// Gives back the next of the arcs start from the given node.
-      ///
+      /// \brief Return the next arc outgoing form the given node.
+      ///
+      /// This function gives back the next arc outgoing form the
+      /// given node.
       void nextOut(Arc&) const {}
 
       /// @}
 
-      /// \name Class based iteration
-      ///
-      /// This interface provides functions for iteration on digraph items
+      /// \name Class Based Iteration
+      ///
+      /// This interface provides iterator classes for digraph items.
       ///
       /// @{
@@ -655,7 +684,7 @@
       typedef GraphItemIt<Digraph, Node> NodeIt;
 
-      /// \brief This iterator goes through each node.
-      ///
-      /// This iterator goes through each node.
+      /// \brief This iterator goes through each arc.
+      ///
+      /// This iterator goes through each arc.
       ///
       typedef GraphItemIt<Digraph, Arc> ArcIt;
@@ -663,5 +692,5 @@
       /// \brief This iterator goes trough the incoming arcs of a node.
       ///
-      /// This iterator goes trough the \e inccoming arcs of a certain node
+      /// This iterator goes trough the \e incoming arcs of a certain node
       /// of a digraph.
       typedef GraphIncIt<Digraph, Arc, Node, 'i'> InArcIt;
@@ -675,24 +704,24 @@
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
-      /// It is always the target of the pointed arc.
+      /// This function gives back the base node of the iterator.
+      /// It is always the target node of the pointed arc.
       Node baseNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
-      /// It is always the source of the pointed arc.
+      /// This function gives back the running node of the iterator.
+      /// It is always the source node of the pointed arc.
       Node runningNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
-      /// It is always the source of the pointed arc.
+      /// This function gives back the base node of the iterator.
+      /// It is always the source node of the pointed arc.
       Node baseNode(const OutArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
-      /// It is always the target of the pointed arc.
+      /// This function gives back the running node of the iterator.
+      /// It is always the target node of the pointed arc.
       Node runningNode(const OutArcIt&) const { return INVALID; }
 
@@ -736,23 +765,24 @@
 
             typename _Digraph::Node n;
-            typename _Digraph::InArcIt ieit(INVALID);
-            typename _Digraph::OutArcIt oeit(INVALID);
-            n = digraph.baseNode(ieit);
-            n = digraph.runningNode(ieit);
-            n = digraph.baseNode(oeit);
-            n = digraph.runningNode(oeit);
-            ignore_unused_variable_warning(n);
+            const typename _Digraph::InArcIt iait(INVALID);
+            const typename _Digraph::OutArcIt oait(INVALID);
+            n = digraph.baseNode(iait);
+            n = digraph.runningNode(iait);
+            n = digraph.baseNode(oait);
+            n = digraph.runningNode(oait);
+            ::lemon::ignore_unused_variable_warning(n);
           }
         }
 
         const _Digraph& digraph;
-
-      };
-    };
-
-    /// \brief An empty iterable undirected graph class.
-    ///
-    /// This class provides beside the core graph features iterator
-    /// based iterable interface for the undirected graph structure.
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for iterable undirected graphs.
+    ///
+    /// This class describes the interface of iterable undirected
+    /// graphs. It extends \ref IterableDigraphComponent with the core
+    /// iterable interface of undirected graphs.
     /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
@@ -768,7 +798,8 @@
       typedef IterableGraphComponent Graph;
 
-      /// \name Base iteration
-      ///
-      /// This interface provides functions for iteration on graph items
+      /// \name Base Iteration
+      ///
+      /// This interface provides functions for iteration on edges.
+      ///
       /// @{
 
@@ -776,26 +807,20 @@
       using IterableDigraphComponent<Base>::next;
 
-      /// \brief Gives back the first edge in the iterating
-      /// order.
-      ///
-      /// Gives back the first edge in the iterating order.
-      ///
+      /// \brief Return the first edge.
+      ///
+      /// This function gives back the first edge in the iteration order.
       void first(Edge&) const {}
 
-      /// \brief Gives back the next edge in the iterating
-      /// order.
-      ///
-      /// Gives back the next edge in the iterating order.
-      ///
+      /// \brief Return the next edge.
+      ///
+      /// This function gives back the next edge in the iteration order.
       void next(Edge&) const {}
 
-
-      /// \brief Gives back the first of the edges from the
+      /// \brief Return the first edge incident to the given node.
+      ///
+      /// This function gives back the first edge incident to the given
+      /// node. The bool parameter gives back the direction for which the
+      /// source node of the directed arc representing the edge is the
       /// given node.
-      ///
-      /// Gives back the first of the edges from the given
-      /// node. The bool parameter gives back that direction which
-      /// gives a good direction of the edge so the source of the
-      /// directed arc is the given node.
       void firstInc(Edge&, bool&, const Node&) const {}
 
@@ -803,7 +828,6 @@
       /// given node.
       ///
-      /// Gives back the next of the edges from the given
-      /// node. The bool parameter should be used as the \c firstInc()
-      /// use it.
+      /// This function gives back the next edge incident to the given
+      /// node. The bool parameter should be used as \c firstInc() use it.
       void nextInc(Edge&, bool&) const {}
 
@@ -813,28 +837,30 @@
       /// @}
 
-      /// \name Class based iteration
-      ///
-      /// This interface provides functions for iteration on graph items
+      /// \name Class Based Iteration
+      ///
+      /// This interface provides iterator classes for edges.
       ///
       /// @{
 
-      /// \brief This iterator goes through each node.
-      ///
-      /// This iterator goes through each node.
+      /// \brief This iterator goes through each edge.
+      ///
+      /// This iterator goes through each edge.
       typedef GraphItemIt<Graph, Edge> EdgeIt;
-      /// \brief This iterator goes trough the incident arcs of a
+
+      /// \brief This iterator goes trough the incident edges of a
       /// node.
       ///
-      /// This iterator goes trough the incident arcs of a certain
+      /// This iterator goes trough the incident edges of a certain
       /// node of a graph.
-      typedef GraphIncIt<Graph, Edge, Node, 'u'> IncEdgeIt;
+      typedef GraphIncIt<Graph, Edge, Node, 'e'> IncEdgeIt;
+
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
+      /// This function gives back the base node of the iterator.
       Node baseNode(const IncEdgeIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
+      /// This function gives back the running node of the iterator.
       Node runningNode(const IncEdgeIt&) const { return INVALID; }
 
@@ -865,24 +891,26 @@
               typename _Graph::EdgeIt >();
             checkConcept<GraphIncIt<_Graph, typename _Graph::Edge,
-              typename _Graph::Node, 'u'>, typename _Graph::IncEdgeIt>();
+              typename _Graph::Node, 'e'>, typename _Graph::IncEdgeIt>();
 
             typename _Graph::Node n;
-            typename _Graph::IncEdgeIt ueit(INVALID);
-            n = graph.baseNode(ueit);
-            n = graph.runningNode(ueit);
+            const typename _Graph::IncEdgeIt ieit(INVALID);
+            n = graph.baseNode(ieit);
+            n = graph.runningNode(ieit);
           }
         }
 
         const _Graph& graph;
-      };
-    };
-
-    /// \brief An empty alteration notifier digraph class.
-    ///
-    /// This class provides beside the core digraph features alteration
-    /// notifier interface for the digraph structure.  This implements
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for alterable directed graphs.
+    ///
+    /// This class describes the interface of alterable directed
+    /// graphs. It extends \ref BaseDigraphComponent with the alteration
+    /// notifier interface. It implements
     /// an observer-notifier pattern for each digraph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the digraph all the observers will
+    /// alteration occured in the digraph all the observers will be
     /// notified about it.
     template <typename BAS = BaseDigraphComponent>
@@ -895,21 +923,21 @@
 
 
-      /// The node observer registry.
+      /// Node alteration notifier class.
       typedef AlterationNotifier<AlterableDigraphComponent, Node>
       NodeNotifier;
-      /// The arc observer registry.
+      /// Arc alteration notifier class.
       typedef AlterationNotifier<AlterableDigraphComponent, Arc>
       ArcNotifier;
 
-      /// \brief Gives back the node alteration notifier.
-      ///
-      /// Gives back the node alteration notifier.
+      /// \brief Return the node alteration notifier.
+      ///
+      /// This function gives back the node alteration notifier.
       NodeNotifier& notifier(Node) const {
-        return NodeNotifier();
+         return NodeNotifier();
       }
 
-      /// \brief Gives back the arc alteration notifier.
-      ///
-      /// Gives back the arc alteration notifier.
+      /// \brief Return the arc alteration notifier.
+      ///
+      /// This function gives back the arc alteration notifier.
       ArcNotifier& notifier(Arc) const {
         return ArcNotifier();
@@ -926,21 +954,21 @@
             = digraph.notifier(typename _Digraph::Arc());
 
-          ignore_unused_variable_warning(nn);
-          ignore_unused_variable_warning(en);
+          ::lemon::ignore_unused_variable_warning(nn);
+          ::lemon::ignore_unused_variable_warning(en);
         }
 
         const _Digraph& digraph;
-
-      };
-
-    };
-
-    /// \brief An empty alteration notifier undirected graph class.
-    ///
-    /// This class provides beside the core graph features alteration
-    /// notifier interface for the graph structure.  This implements
-    /// an observer-notifier pattern for each graph item. More
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for alterable undirected graphs.
+    ///
+    /// This class describes the interface of alterable undirected
+    /// graphs. It extends \ref AlterableDigraphComponent with the alteration
+    /// notifier interface of undirected graphs. It implements
+    /// an observer-notifier pattern for the edges. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the graph all the observers will
+    /// alteration occured in the graph all the observers will be
     /// notified about it.
     template <typename BAS = BaseGraphComponent>
@@ -952,11 +980,11 @@
 
 
-      /// The arc observer registry.
+      /// Edge alteration notifier class.
       typedef AlterationNotifier<AlterableGraphComponent, Edge>
       EdgeNotifier;
 
-      /// \brief Gives back the arc alteration notifier.
-      ///
-      /// Gives back the arc alteration notifier.
+      /// \brief Return the edge alteration notifier.
+      ///
+      /// This function gives back the edge alteration notifier.
       EdgeNotifier& notifier(Edge) const {
         return EdgeNotifier();
@@ -966,40 +994,47 @@
       struct Constraints {
         void constraints() {
-          checkConcept<AlterableGraphComponent<Base>, _Graph>();
+          checkConcept<AlterableDigraphComponent<Base>, _Graph>();
           typename _Graph::EdgeNotifier& uen
             = graph.notifier(typename _Graph::Edge());
-          ignore_unused_variable_warning(uen);
+          ::lemon::ignore_unused_variable_warning(uen);
         }
 
         const _Graph& graph;
-      };
-    };
-
-    /// \brief Class describing the concept of graph maps
-    ///
-    /// This class describes the common interface of the graph maps
-    /// (NodeMap, ArcMap), that is maps that can be used to
-    /// associate data to graph descriptors (nodes or arcs).
+        Constraints() {}
+      };
+    };
+
+    /// \brief Concept class for standard graph maps.
+    ///
+    /// This class describes the concept of standard graph maps, i.e.
+    /// the \c NodeMap, \c ArcMap and \c EdgeMap subtypes of digraph and
+    /// graph types, which can be used for associating data to graph items.
+    /// The standard graph maps must conform to the ReferenceMap concept.
     template <typename GR, typename K, typename V>
-    class GraphMap : public ReadWriteMap<K, V> {
-    public:
-
-      typedef ReadWriteMap<K, V> Parent;
-
-      /// The graph type of the map.
-      typedef GR Graph;
+    class GraphMap : public ReferenceMap<K, V, V&, const V&> {
+      typedef ReferenceMap<K, V, V&, const V&> Parent;
+
+    public:
+
       /// The key type of the map.
       typedef K Key;
       /// The value type of the map.
       typedef V Value;
+      /// The reference type of the map.
+      typedef Value& Reference;
+      /// The const reference type of the map.
+      typedef const Value& ConstReference;
+
+      // The reference map tag.
+      typedef True ReferenceMapTag;
 
       /// \brief Construct a new map.
       ///
       /// Construct a new map for the graph.
-      explicit GraphMap(const Graph&) {}
+      explicit GraphMap(const GR&) {}
       /// \brief Construct a new map with default value.
       ///
-      /// Construct a new map for the graph and initalise the values.
-      GraphMap(const Graph&, const Value&) {}
+      /// Construct a new map for the graph and initalize the values.
+      GraphMap(const GR&, const Value&) {}
 
     private:
@@ -1009,7 +1044,7 @@
       GraphMap(const GraphMap&) : Parent() {}
 
-      /// \brief Assign operator.
-      ///
-      /// Assign operator. It does not mofify the underlying graph,
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator. It does not mofify the underlying graph,
       /// it just iterates on the current item set and set the  map
       /// with the value returned by the assigned map.
@@ -1024,31 +1059,34 @@
       struct Constraints {
         void constraints() {
-          checkConcept<ReadWriteMap<Key, Value>, _Map >();
-          // Construction with a graph parameter
-          _Map a(g);
-          // Constructor with a graph and a default value parameter
-          _Map a2(g,t);
-          // Copy constructor.
-          // _Map b(c);
-
+          checkConcept
+            <ReferenceMap<Key, Value, Value&, const Value&>, _Map>();
+          _Map m1(g);
+          _Map m2(g,t);
+
+          // Copy constructor
+          // _Map m3(m);
+
+          // Assignment operator
           // ReadMap<Key, Value> cmap;
-          // b = cmap;
-
-          ignore_unused_variable_warning(a);
-          ignore_unused_variable_warning(a2);
-          // ignore_unused_variable_warning(b);
-        }
-
-        const _Map &c;
-        const Graph &g;
+          // m3 = cmap;
+
+          ::lemon::ignore_unused_variable_warning(m1);
+          ::lemon::ignore_unused_variable_warning(m2);
+          // ::lemon::ignore_unused_variable_warning(m3);
+        }
+
+        const _Map &m;
+        const GR &g;
         const typename GraphMap::Value &t;
-      };
-
-    };
-
-    /// \brief An empty mappable digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// map interface for the digraph structure.
+        Constraints() {}
+      };
+
+    };
+
+    /// \brief Skeleton class for mappable directed graphs.
+    ///
+    /// This class describes the interface of mappable directed graphs.
+    /// It extends \ref BaseDigraphComponent with the standard digraph
+    /// map classes, namely \c NodeMap and \c ArcMap.
     /// This concept is part of the Digraph concept.
     template <typename BAS = BaseDigraphComponent>
@@ -1062,13 +1100,13 @@
       typedef MappableDigraphComponent Digraph;
 
-      /// \brief ReadWrite map of the nodes.
-      ///
-      /// ReadWrite map of the nodes.
-      ///
+      /// \brief Standard graph map for the nodes.
+      ///
+      /// Standard graph map for the nodes.
+      /// It conforms to the ReferenceMap concept.
       template <typename V>
-      class NodeMap : public GraphMap<Digraph, Node, V> {
+      class NodeMap : public GraphMap<MappableDigraphComponent, Node, V> {
+        typedef GraphMap<MappableDigraphComponent, Node, V> Parent;
+
       public:
-        typedef GraphMap<MappableDigraphComponent, Node, V> Parent;
-
         /// \brief Construct a new map.
         ///
@@ -1079,5 +1117,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalise the values.
+        /// Construct a new map for the digraph and initalize the values.
         NodeMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
@@ -1089,7 +1127,7 @@
         NodeMap(const NodeMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
+        /// \brief Assignment operator.
         ///
-        /// Assign operator.
+        /// Assignment operator.
         template <typename CMap>
         NodeMap& operator=(const CMap&) {
@@ -1100,13 +1138,13 @@
       };
 
-      /// \brief ReadWrite map of the arcs.
-      ///
-      /// ReadWrite map of the arcs.
-      ///
+      /// \brief Standard graph map for the arcs.
+      ///
+      /// Standard graph map for the arcs.
+      /// It conforms to the ReferenceMap concept.
       template <typename V>
-      class ArcMap : public GraphMap<Digraph, Arc, V> {
+      class ArcMap : public GraphMap<MappableDigraphComponent, Arc, V> {
+        typedef GraphMap<MappableDigraphComponent, Arc, V> Parent;
+
       public:
-        typedef GraphMap<MappableDigraphComponent, Arc, V> Parent;
-
         /// \brief Construct a new map.
         ///
@@ -1117,5 +1155,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalise the values.
+        /// Construct a new map for the digraph and initalize the values.
         ArcMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
@@ -1127,7 +1165,7 @@
         ArcMap(const ArcMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
+        /// \brief Assignment operator.
         ///
-        /// Assign operator.
+        /// Assignment operator.
         template <typename CMap>
         ArcMap& operator=(const CMap&) {
@@ -1179,12 +1217,14 @@
         }
 
-        _Digraph& digraph;
-      };
-    };
-
-    /// \brief An empty mappable base bipartite graph class.
-    ///
-    /// This class provides beside the core graph features
-    /// map interface for the graph structure.
+        const _Digraph& digraph;
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for mappable undirected graphs.
+    ///
+    /// This class describes the interface of mappable undirected graphs.
+    /// It extends \ref MappableDigraphComponent with the standard graph
+    /// map class for edges (\c EdgeMap).
     /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
@@ -1197,13 +1237,13 @@
       typedef MappableGraphComponent Graph;
 
-      /// \brief ReadWrite map of the edges.
-      ///
-      /// ReadWrite map of the edges.
-      ///
+      /// \brief Standard graph map for the edges.
+      ///
+      /// Standard graph map for the edges.
+      /// It conforms to the ReferenceMap concept.
       template <typename V>
-      class EdgeMap : public GraphMap<Graph, Edge, V> {
+      class EdgeMap : public GraphMap<MappableGraphComponent, Edge, V> {
+        typedef GraphMap<MappableGraphComponent, Edge, V> Parent;
+
       public:
-        typedef GraphMap<MappableGraphComponent, Edge, V> Parent;
-
         /// \brief Construct a new map.
         ///
@@ -1214,5 +1254,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the graph and initalise the values.
+        /// Construct a new map for the graph and initalize the values.
         EdgeMap(const MappableGraphComponent& graph, const V& value)
           : Parent(graph, value) {}
@@ -1224,7 +1264,7 @@
         EdgeMap(const EdgeMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
+        /// \brief Assignment operator.
         ///
-        /// Assign operator.
+        /// Assignment operator.
         template <typename CMap>
         EdgeMap& operator=(const CMap&) {
@@ -1246,5 +1286,5 @@
 
         void constraints() {
-          checkConcept<MappableGraphComponent<Base>, _Graph>();
+          checkConcept<MappableDigraphComponent<Base>, _Graph>();
 
           { // int map test
@@ -1263,14 +1303,15 @@
         }
 
-        _Graph& graph;
-      };
-    };
-
-    /// \brief An empty extendable digraph class.
-    ///
-    /// This class provides beside the core digraph features digraph
-    /// extendable interface for the digraph structure.  The main
-    /// difference between the base and this interface is that the
-    /// digraph alterations should handled already on this level.
+        const _Graph& graph;
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for extendable directed graphs.
+    ///
+    /// This class describes the interface of extendable directed graphs.
+    /// It extends \ref BaseDigraphComponent with functions for adding
+    /// nodes and arcs to the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
     template <typename BAS = BaseDigraphComponent>
     class ExtendableDigraphComponent : public BAS {
@@ -1281,15 +1322,15 @@
       typedef typename Base::Arc Arc;
 
-      /// \brief Adds a new node to the digraph.
-      ///
-      /// Adds a new node to the digraph.
-      ///
+      /// \brief Add a new node to the digraph.
+      ///
+      /// This function adds a new node to the digraph.
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Adds a new arc connects the given two nodes.
-      ///
-      /// Adds a new arc connects the the given two nodes.
+      /// \brief Add a new arc connecting the given two nodes.
+      ///
+      /// This function adds a new arc connecting the given two nodes
+      /// of the digraph.
       Arc addArc(const Node&, const Node&) {
         return INVALID;
@@ -1308,14 +1349,14 @@
 
         _Digraph& digraph;
-      };
-    };
-
-    /// \brief An empty extendable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core undircted graph extend interface for the graph structure.
-    /// The main difference between the base and this interface is
-    /// that the graph alterations should handled already on this
-    /// level.
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for extendable undirected graphs.
+    ///
+    /// This class describes the interface of extendable undirected graphs.
+    /// It extends \ref BaseGraphComponent with functions for adding
+    /// nodes and edges to the graph.
+    /// This concept requires \ref AlterableGraphComponent.
     template <typename BAS = BaseGraphComponent>
     class ExtendableGraphComponent : public BAS {
@@ -1326,16 +1367,16 @@
       typedef typename Base::Edge Edge;
 
-      /// \brief Adds a new node to the graph.
-      ///
-      /// Adds a new node to the graph.
-      ///
+      /// \brief Add a new node to the digraph.
+      ///
+      /// This function adds a new node to the digraph.
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Adds a new arc connects the given two nodes.
-      ///
-      /// Adds a new arc connects the the given two nodes.
-      Edge addArc(const Node&, const Node&) {
+      /// \brief Add a new edge connecting the given two nodes.
+      ///
+      /// This function adds a new edge connecting the given two nodes
+      /// of the graph.
+      Edge addEdge(const Node&, const Node&) {
         return INVALID;
       }
@@ -1353,13 +1394,14 @@
 
         _Graph& graph;
-      };
-    };
-
-    /// \brief An empty erasable digraph class.
-    ///
-    /// This class provides beside the core digraph features core erase
-    /// functions for the digraph structure. The main difference between
-    /// the base and this interface is that the digraph alterations
-    /// should handled already on this level.
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for erasable directed graphs.
+    ///
+    /// This class describes the interface of erasable directed graphs.
+    /// It extends \ref BaseDigraphComponent with functions for removing
+    /// nodes and arcs from the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
     template <typename BAS = BaseDigraphComponent>
     class ErasableDigraphComponent : public BAS {
@@ -1372,12 +1414,11 @@
       /// \brief Erase a node from the digraph.
       ///
-      /// Erase a node from the digraph. This function should
-      /// erase all arcs connecting to the node.
+      /// This function erases the given node from the digraph and all arcs
+      /// connected to the node.
       void erase(const Node&) {}
 
       /// \brief Erase an arc from the digraph.
       ///
-      /// Erase an arc from the digraph.
-      ///
+      /// This function erases the given arc from the digraph.
       void erase(const Arc&) {}
 
@@ -1386,20 +1427,21 @@
         void constraints() {
           checkConcept<Base, _Digraph>();
-          typename _Digraph::Node node;
+          const typename _Digraph::Node node(INVALID);
           digraph.erase(node);
-          typename _Digraph::Arc arc;
+          const typename _Digraph::Arc arc(INVALID);
           digraph.erase(arc);
         }
 
         _Digraph& digraph;
-      };
-    };
-
-    /// \brief An empty erasable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core erase functions for the undirceted graph structure. The
-    /// main difference between the base and this interface is that
-    /// the graph alterations should handled already on this level.
+        Constraints() {}
+      };
+    };
+
+    /// \brief Skeleton class for erasable undirected graphs.
+    ///
+    /// This class describes the interface of erasable undirected graphs.
+    /// It extends \ref BaseGraphComponent with functions for removing
+    /// nodes and edges from the graph.
+    /// This concept requires \ref AlterableGraphComponent.
     template <typename BAS = BaseGraphComponent>
     class ErasableGraphComponent : public BAS {
@@ -1412,12 +1454,11 @@
       /// \brief Erase a node from the graph.
       ///
-      /// Erase a node from the graph. This function should erase
-      /// arcs connecting to the node.
+      /// This function erases the given node from the graph and all edges
+      /// connected to the node.
       void erase(const Node&) {}
 
-      /// \brief Erase an arc from the graph.
-      ///
-      /// Erase an arc from the graph.
-      ///
+      /// \brief Erase an edge from the digraph.
+      ///
+      /// This function erases the given edge from the digraph.
       void erase(const Edge&) {}
 
